#!/usr/bin/python

import socket
import threading
import md5
import tcpserver
import process

class PopenHandler(threading.Thread):
    def __init__(self, sock):
        threading.Thread.__init__(self)
        self.sock = sock
        self.bufSize = 1024
        self.running = False
        self.password = md5.new('password').hexdigest()
        self.program = None
        self.pid = None
    
    def run(self):
        self.running = self.validPass()
        while self.running:
            self.parseLine()    
        print 'closing client socket')
        self.sock.close()
    
    def validPass(self):
        recvPass = self.getLine()
        if recvPass == self.password:
            self.sendLine('success')
        else:
            self.sendLine('failure')
        return recvPass == self.password
    
    def parseLine(self):
        line = self.getLine()
        if line == '':
            self.running = False
            return
        cmd, args = line.split(' ', 1)
        if cmd == 'open':
            self.program = process.Process(args)
            self.pid = str(self.program.pid)
            self.sendAck()
        elif cmd == 'kill':
            self.program.kill()
            self.sendAck()
        elif cmd == 'wait':
            self.program.wait()
            self.sendAck()
        elif cmd == 'stdout':
            self.sendLine(self.program.readline('stdout'))
        elif cmd == 'stderr':
            self.sendLine(self.program.readline('stderr'))
        else:
            print 'incorrect input: ' + line

    def sendAck(self, success=True):
        if success:
            self.sendLine(self.pid)
        else:
            self.sendLine('-1')       

    def sendLine(self, strMsg):
        self.sock.send(strMsg)

    def getLine(self):
        return self.sock.recv(self.bufSize)
        
def quit(server):
    raw_input('Press enter to exit...\n')
    server.serving = False

if __name__=='__main__':
    server = tcpserver.TCPServer(60001, PopenHandler)
    threading.Thread(target=quit, args=(server,)).start()
    server.start()

